#!/bin/sh

. /etc/PG.conf
. ${PGETC}/httpd.conf

APIROOT="${dir}/cgi-bin"
USERDIR="/usr/ramdisk/etc/webuser"
WEBLOGIN="/usr/ramdisk/weblogin"

FLOWEYE="/usr/ramdisk/bin/floweye"
ESCTOOL="/usr/ramdisk/bin/esctool"


print_json_head()
{
	printf "Content-Type:application/json;charset=gb2312\r\n"
	printf "\r\n"
}


retjson()
{
	print_json_head
	
	if [ "${3}" = "" ]; then
		echo -n "{ \"code\": ${1}, \"msg\": \"${2}\", \"data\": \"\"}"
	else
		echo -n "{ \"code\": ${1}, \"msg\": \"${2}\", \"data\": ${3}}"
	fi

	exit 0
}


WEB_LOGGER()
{	
	# $1 User
	# $2 Action
	# $3 Message

	local logfile="${DATAPATH}/web_`date +%Y.%m.%d`.log"
	local curtime="`date +%Y.%m.%d/%H:%M:%S`"

	echo "${curtime} ${REMOTE_ADDR} $1 $2 $3" >> ${logfile}
	sync
	sync
}


cookie_make()
{
	logintime="`date +%s1`"
	code="`/usr/ramdisk/bin/ipe_mkcode`"
	esc_code="`${ESCTOOL} -e ${code}`"
	echo "paonline_${CGI_username}_$$_${logintime}_${esc_code}_${SERVER_PORT}"
}


api_login()
{
	[ "${CGI_username}" = "" ] && retjson 1 "ûΪ"
	[ "${CGI_password}" = "" ] && retjson 1 "벻Ϊ"
	
	aes_name="`${ESCTOOL} -e ${CGI_username}`"
	usr_file="${USERDIR}/${aes_name}"
	
	[ ! -f "${usr_file}" ] && retjson 1 "û"
	
	. ${usr_file}
	aes_pswd="`${ESCTOOL} -e ${CGI_password}`"
	[ "${aes_pswd}" != "${password}" ] && retjson 1 "֤ʧܣ˺"
	
	mkdir -p "${WEBLOGIN}"
	ckinfo="`cookie_make`"
	ckfile="${WEBLOGIN}/${ckinfo}"
	CGI_username="${CGI_username}@api"

	echo "ip=${REMOTE_ADDR}" > ${ckfile}
	echo "user=${CGI_username}" >> ${ckfile}
	echo "login_level=${level}" >> ${ckfile}
	echo "logintime=`date +%Y.%m.%d/%H:%M:%S`" >> ${ckfile}
	
	WEB_LOGGER  "${CGI_username}" "ûAPIӿڵ¼" "user=${CGI_username},ip=${REMOTE_ADDR}"
	retjson 0 "¼ɹ" "\"${ckinfo}\""
}


api_proxy()
{
	[ "${CGI_api_token}" = "" ] && retjson 1 "TOKENΪ"
	token_file="${WEBLOGIN}/${CGI_api_token}"
	[ "`dirname ${token_file}`" != "${WEBLOGIN}" ] && retjson 1 "TOKEN"
	[ ! -f "${token_file}" ] && retjson 1 "APIδ¼"
	
	[ "${CGI_api_route}" = "" ] && retjson 1 "ӿ·ɲΪ"
	
	api_path="`echo ${CGI_api_route} | cut -d '@' -f1`"
	api_file="ajax_`echo ${CGI_api_route} | cut -d '@' -f2`"

	[ ! -d "${APIROOT}/${api_path}" ] && retjson 1 "δ֪·"
	[ ! -f "${APIROOT}/${api_path}/${api_file}" ] && retjson 1 "δ֪ӿ"

	_dirname="`dirname ${APIROOT}/${api_path}/${api_file}`"
	[ "${_dirname}" != "${APIROOT}/${api_path}" ] && retjson 1 "Ľӿڷ"
	
	cd ../cgi-bin/${api_path}

	username=`echo ${CGI_api_token} | cut -d"_" -f2`
	export CGI_action="${CGI_api_action}"
	export PANABIT_USER="${username}@api"
	
	sh ${api_file}
}


case "${CGI_api_action}" in
	"api_login")
		api_login
		;;
		
	*)
		api_proxy
		;;
esac
