#!/bin/sh

# Please see pppoedb.h

TMPDIR=/usr/ramdisk/tmp
DBFILE=${TMPDIR}/account.conf
mkdir -p ${TMPDIR}
[ -e ${DBFILE} ] && rm -f ${DBFILE}
touch ${DBFILE}

. /etc/PG.conf

# Process group first
if [ -f ${PGETC}/pppoedb.conf ]; then
	exec 0<${PGETC}/pppoedb.conf
	while read type id name start end rin rout others
	do
		if [ "${type}" = "ippool" ]; then 
			# drop empty pool 
			pid=`echo ${id} | cut -d'=' -f2`
			if [ "${name}" = "name=pool${pid}" -a \
			     "${start}" = "start=0.0.0.0" -a \
			     "${end}" = "end=0.0.0.0" -a \
			     "${rin}" = "ratein=0" -a \
			     "${rout}" = "rateout=0" ]; then
				continue
			fi

			echo "g id=${pid} ${name} ${start} ${end} ${rin} ${rout} ${others}" >> ${DBFILE}
		elif [ "${type}" = "acct" ]; then
			pid=`echo ${id} | cut -d'=' -f2`
			echo "u g=${pid} ${name} ${start} ${end} ${rin} ${rout} ${others}" >> ${DBFILE}
		fi
	done
fi

echo "group id=0 name=DefaultGroup" >> ${DBFILE}
if [ -f ${PGETC}/usrinfo.conf ]; then
	cat ${PGETC}/usrinfo.conf >> ${DBFILE}
fi

mv ${DBFILE} ${PGETC}/account.conf
